#include "header.h"

void show_image (TM *tm) {
  GError **error = NULL;

  if (check_ext(tm->tnfo->image_full_path) == 2) {
    tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_full_path, error);
    tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
    tm->tgtk->animation_orig = tm->tgtk->animation;
  } else {
      if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
	int width, height;
	gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_full_path, width - 300, height - 100, TRUE, NULL);
      } else {
    tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_full_path, error);
      }
    tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
    tm->tgtk->pixbuf_orig = tm->tgtk->pixbuf; // save a copy of the original image
  }

  fill_nfo(tm);

  tm->tnfo->image_width_orig = tm->tnfo->image_width;
  tm->tnfo->image_height_orig = tm->tnfo->image_height;
    
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
  gtk_widget_show(tm->tgtk->image);

  fill_image_list(tm);
  fill_right_sidebar(tm);

  if (tm->tnfo->pos == tm->tnfo->total - 1) {
    // button next becomes inactive
    gtk_widget_set_sensitive(tm->tgtk->menu_next, FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->next), FALSE);
    
  }
  if (tm->tnfo->pos == 0) {
    // button prev becomes inactive
    gtk_widget_set_sensitive(tm->tgtk->menu_prev, FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->prev), FALSE);
  }
}

void zoom_in_image (TM *tm) {
  GdkPixbuf *pixbuf;
  int new_width, new_height;
  //  int times, factor;

  if (tm->tgtk->pixbuf != NULL) {
    fill_nfo(tm);
    if (tm->tnfo->image_width < tm->tnfo->image_width_orig * 5 ||
	tm->tnfo->image_height < tm->tnfo->image_height_orig * 5) {
      new_width = tm->tnfo->image_width + tm->tnfo->image_width * (20 / 100.0);
      new_height = tm->tnfo->image_height + tm->tnfo->image_height * (20 / 100.0);
      pixbuf = gdk_pixbuf_scale_simple(tm->tgtk->pixbuf, new_width, new_height, GDK_INTERP_BILINEAR);
      gtk_widget_destroy(tm->tgtk->image);
      tm->tgtk->image = gtk_image_new_from_pixbuf(pixbuf);
      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
      gtk_widget_show(tm->tgtk->image);
      tm->tgtk->pixbuf = pixbuf;
    }
  }
}

void zoom_out_image (TM *tm) {
  GdkPixbuf *pixbuf;
  int new_width, new_height;

  if (tm->tgtk->pixbuf != NULL) {
    fill_nfo(tm);
    if (tm->tnfo->image_width > tm->tnfo->image_width_orig / 5.0 ||
	tm->tnfo->image_height > tm->tnfo->image_height_orig * 5.0) {
      new_width = tm->tnfo->image_width - tm->tnfo->image_width * (20 / 100.0);
      new_height = tm->tnfo->image_height - tm->tnfo->image_height * (20 / 100.0);
      pixbuf = gdk_pixbuf_scale_simple(tm->tgtk->pixbuf, new_width, new_height, GDK_INTERP_BILINEAR);
      gtk_widget_destroy(tm->tgtk->image);
      tm->tgtk->image = gtk_image_new_from_pixbuf(pixbuf);
      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
      gtk_widget_show(tm->tgtk->image);
      tm->tgtk->pixbuf = pixbuf;
    }
  }
}

void rotate_left_image (TM *tm) {
  GdkPixbuf *pixbuf;

  if (tm->tgtk->pixbuf != NULL) {
    pixbuf = gdk_pixbuf_rotate_simple(tm->tgtk->pixbuf, 90);
    gtk_widget_destroy(tm->tgtk->image);
    tm->tgtk->image = gtk_image_new_from_pixbuf(pixbuf);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
    gtk_widget_show(tm->tgtk->image);
    tm->tgtk->pixbuf = pixbuf;
  }
}

void rotate_right_image (TM *tm) {
  GdkPixbuf *pixbuf;

  if (tm->tgtk->pixbuf != NULL) {
    pixbuf = gdk_pixbuf_rotate_simple(tm->tgtk->pixbuf, 270);
    gtk_widget_destroy(tm->tgtk->image);
    tm->tgtk->image = gtk_image_new_from_pixbuf(pixbuf);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
    gtk_widget_show(tm->tgtk->image);
    tm->tgtk->pixbuf = pixbuf;
  }
}

void flip_image (TM *tm) {
  GdkPixbuf *pixbuf;

  if (tm->tgtk->pixbuf != NULL) {
    pixbuf = gdk_pixbuf_flip(tm->tgtk->pixbuf, FALSE);
    gtk_widget_destroy(tm->tgtk->image);
    tm->tgtk->image = gtk_image_new_from_pixbuf(pixbuf);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
    gtk_widget_show(tm->tgtk->image);
    tm->tgtk->pixbuf = pixbuf;
  }
}

void fill_nfo (TM *tm) {
  if (GDK_IS_PIXBUF(tm->tgtk->pixbuf)) {
    tm->tnfo->image_width = gdk_pixbuf_get_width(tm->tgtk->pixbuf);
    tm->tnfo->image_height = gdk_pixbuf_get_height(tm->tgtk->pixbuf);
  }
}

void load_orig_image (TM *tm) {
  tm->tgtk->pixbuf = tm->tgtk->pixbuf_orig;
  gtk_widget_destroy(tm->tgtk->image);
  tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf_orig);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
  gtk_widget_show(tm->tgtk->image);
}

void fill_image_list (TM *tm) {
  int i, seen = 0, save;
  /*
    for (i = 0; i < tm->tnfo->total; i++) {
    free(tm->tnfo->image_list[i]);
    }
    free(tm->tnfo->image_list);
  */
  if (tm->tnfo->image_full_path == NULL) {
    // no image has been loaded yet
    tm->tnfo->image_dirname = malloc(strlen(tm->tcfg->start_dir) + 1);
    if (!tm->tnfo->image_dirname) {
      criterr(0);
    }
    strcpy(tm->tnfo->image_dirname, tm->tcfg->start_dir);
  } else { // an image was loaded, get the dirname
    tm->tnfo->image_dirname = malloc(PATH_LENGTH + 1);
    if (!tm->tnfo->image_dirname) {
      criterr(0);
    }
    i = strlen(tm->tnfo->image_full_path) - 1;
    seen = 0;
    while (i >= 0 && seen == 0) {
      if (tm->tnfo->image_full_path[i] == '/') {
	seen = 1;
	save = i;
      }
      i--;
    }
    if (seen == 0) {
      strcpy(tm->tnfo->image_dirname, tm->tenv->cwd);
    } else {
      for (i = 0; i <= save - 1; i++) {
	tm->tnfo->image_dirname[i] = tm->tnfo->image_full_path[i];
      }
      tm->tnfo->image_dirname[i] = '\0';
    }
  }

  //  fprintf(stdout, "[NeonView] Image directory: %s\n", tm->tnfo->image_dirname);

  // now we need to fill in image_list*
  // for each file in dirname, check extension to see if it's an image
  // if it is, put it in image_list
  // TODO: use gdk_loader to check for formats rather than manually?

  DIR *dir;
  struct dirent *ent;

  dir = opendir(tm->tnfo->image_dirname);
  if (!dir) {
    criterr(2);
  }
  // count the number of images in directory
  tm->tnfo->total = 0;
  while((ent = readdir(dir)) != NULL) {
    if (check_ext(ent->d_name) > 0) {
      tm->tnfo->total++;
    }
  }
  closedir(dir);
  // allocate total number of char pointers
  tm->tnfo->image_list = malloc(tm->tnfo->total * sizeof(char*));
  tm->tnfo->image_list_basename = malloc(tm->tnfo->total * sizeof(char*));
  if (!tm->tnfo->image_list || !tm->tnfo->image_list_basename) {
    criterr(0);
  }

  dir = opendir(tm->tnfo->image_dirname);
  if (!dir) {
    criterr(2);
  }
  // fill in image_list
  i = 0;
  while ((ent = readdir(dir)) != NULL) {
    if (check_ext(ent->d_name) > 0) { // we have an image
      // additional + 1 for the "/" char
      tm->tnfo->image_list[i] = malloc(strlen(tm->tnfo->image_dirname) + strlen(ent->d_name) + 1 + 1);
      tm->tnfo->image_list_basename[i] = malloc(strlen(ent->d_name) + 1);
      if (!tm->tnfo->image_list[i] || !tm->tnfo->image_list_basename) {
	criterr(0);
      }
      strcpy(tm->tnfo->image_list[i], tm->tnfo->image_dirname);
      strcat(tm->tnfo->image_list[i], "/");
      strcat(tm->tnfo->image_list[i], ent->d_name);
      strcpy(tm->tnfo->image_list_basename[i], ent->d_name);
      i++;
    }
  }
  closedir(dir);

  for (i = 0; i < tm->tnfo->total; i++) {
    //    fprintf(stdout, "tm->tnfo->image_list[%d] = %s\n", i, tm->tnfo->image_list[i]);
    /*
      if (strstr(tm->tnfo->image_list[i], tm->tnfo->image_path)) {
      tm->tnfo->pos = i;
      }
    */
    if (strstr(tm->tnfo->image_list[i], tm->tnfo->image_basename)) {
      tm->tnfo->pos = i;
    }
  }
}

void show_prev (TM *tm) {
  if (tm->tnfo->pos > 0) {
    GError **error = NULL;

    tm->tnfo->pos--;

    if (tm->tgtk->image != NULL) {
      gtk_widget_destroy(tm->tgtk->image);
    }

    if (check_ext(tm->tnfo->image_list[tm->tnfo->pos]) == 2) {
      tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
      tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
      tm->tgtk->animation_orig = tm->tgtk->animation;
    } else {
      if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
	int width, height;
	gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_list[tm->tnfo->pos], width - 300, height - 100, TRUE, NULL);
      } else {
      tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
      }
      tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
      //      tm->tgtk->pixbuf_orig = tm->tgtk->pixbuf; // save a copy of the original image
      tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], NULL);
    }

    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
    gtk_widget_show(tm->tgtk->image);

    fill_nfo(tm);
    fill_right_sidebar(tm);
    //    get_full_path(tm);

    if (tm->tnfo->pos == 0) {
      // button becomes inactive
      gtk_widget_set_sensitive(tm->tgtk->menu_prev, FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->prev), FALSE);
    }
    gtk_widget_set_sensitive(tm->tgtk->menu_next, TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->next), TRUE);

    put_status(tm);
  }
}

void show_next (TM *tm) {
  if (tm->tnfo->pos < tm->tnfo->total - 1) {
    tm->tnfo->pos++;

    GError **error = NULL;

    if (tm->tgtk->image != NULL) {
      gtk_widget_destroy(tm->tgtk->image);
    }

    if (check_ext(tm->tnfo->image_list[tm->tnfo->pos]) == 2) {
      tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
      tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
      tm->tgtk->animation_orig = tm->tgtk->animation;
    } else {
      if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
	int width, height;
	gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_list[tm->tnfo->pos], width - 300, height - 100, TRUE, NULL);
      } else {
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
      }
      tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
      //      tm->tgtk->pixbuf_orig = tm->tgtk->pixbuf; // save a copy of the original image
      tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], NULL);
    }

    if (tm->tgtk->pixbuf != NULL && GDK_IS_PIXBUF(tm->tgtk->pixbuf)) {

      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
      gtk_widget_show(tm->tgtk->image);

      fill_nfo(tm);
      fill_right_sidebar(tm);
    } else {
      // if no image was loaded but there are images in current dir, this will be active
      if (check_ext(tm->tnfo->image_list[tm->tnfo->pos]) == 2) {
	tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
	tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
	tm->tgtk->animation_orig = tm->tgtk->animation;
      } else {
      if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
	int width, height;
	gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_list[tm->tnfo->pos], width - 300, height - 100, TRUE, NULL);
      } else {
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], error);
      }
	tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
	//	tm->tgtk->pixbuf_orig = tm->tgtk->pixbuf; // save a copy of the original image
	tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_list[tm->tnfo->pos], NULL);
      }

      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
      gtk_widget_show(tm->tgtk->image);

      fill_nfo(tm);
      fill_right_sidebar(tm);
      //      get_full_path(tm);
    }

    gtk_widget_set_sensitive(tm->tgtk->menu_prev, TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->prev), TRUE);

    put_status(tm);
  }
  if (tm->tnfo->pos == tm->tnfo->total - 1) {
    // button becomes inactive
    gtk_widget_set_sensitive(tm->tgtk->menu_next, FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->next), FALSE);
  } else {
  }

}

void fill_right_sidebar (TM *tm) {
  // title
  gtk_entry_set_text(GTK_ENTRY(tm->tgtk->entry21), tm->tnfo->image_list_basename[tm->tnfo->pos]);
  // resolution
  char width[digits(tm->tnfo->image_width) + 1];
  char height[digits(tm->tnfo->image_height) + 1];
  char str[sizeof(width) + sizeof(height)]; // should be -1, but 'x' gets a char too
  if (GDK_IS_PIXBUF(tm->tgtk->pixbuf)) {
    sprintf(width, "%d", tm->tnfo->image_width);
    sprintf(height, "%d", tm->tnfo->image_height);
    strcpy(str, width);
    strcat(str, "x");
    strcat(str, height);
  } else {
    strcpy(str, "0x0");
  }
  gtk_entry_set_text(GTK_ENTRY(tm->tgtk->entry22), str);
  // size
  long size, mb = 0, kb = 0, bytes = 0;
  float newsize;
  size = filesize(tm->tnfo->image_list[tm->tnfo->pos]);
  if (size > 1024 * 1024) { // > 1MB
    newsize = size / (1024.0 * 1024.0);
    mb = 1;
  } else {
    if (size > 1024) { // > 1KB
      newsize = size / 1024.0;
      kb = 1;
    } else {
      newsize = size;
      bytes = 1;
    }
  }
  sprintf(str, "%.2f", newsize);
  if (mb == 1) { strcat(str, " MB"); }
  if (kb == 1) { strcat(str, " KB"); }
  if (bytes == 1) { strcat(str, " bytes"); }
  if (newsize == 0) { strcpy(str, "0 bytes"); }
  //  sprintf(str, "%ld", filesize(tm->tnfo->image_list[tm->tnfo->pos]));
  gtk_entry_set_text(GTK_ENTRY(tm->tgtk->entry23), str);
  // path
  gtk_entry_set_text(GTK_ENTRY(tm->tgtk->entry24), tm->tnfo->image_dirname);
}

void thumb_show (TM *tm, GtkWidget *button) {
  GError **error = NULL;
  int i;

  for (i = 0; i < tm->tnfo->total; i++) {
    if (tm->tgtk->button[i] == button) {
      if (tm->tgtk->image != NULL) {
	gtk_widget_destroy(tm->tgtk->image);
      }

      if (check_ext(tm->tnfo->image_list[i]) == 2) {
	tm->tgtk->animation = gdk_pixbuf_animation_new_from_file(tm->tnfo->image_list[i], error);
	tm->tgtk->image = gtk_image_new_from_animation(tm->tgtk->animation);
	tm->tgtk->animation_orig = tm->tgtk->animation;
      } else {
      if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
	int width, height;
	gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_list[i], width - 300, height - 100, TRUE, NULL);
      } else {
	tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_list[i], error);
      }
	tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
	tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_list[i], NULL);

      }

      gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
      gtk_widget_show(tm->tgtk->image);

      tm->tnfo->pos = i;

      fill_nfo(tm);
      fill_right_sidebar(tm);
      put_status(tm);

      if (i == tm->tnfo->total - 1) {
	gtk_widget_set_sensitive(tm->tgtk->menu_next, FALSE);
	gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->next), FALSE);
      } else {
	gtk_widget_set_sensitive(tm->tgtk->menu_next, TRUE);
	gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->next), TRUE);
      }
      if (i == 0) {
	gtk_widget_set_sensitive(tm->tgtk->menu_prev, FALSE);
	gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->prev), FALSE);
      } else {
	gtk_widget_set_sensitive(tm->tgtk->menu_prev, TRUE);
	gtk_widget_set_sensitive(GTK_WIDGET(tm->tgtk->prev), TRUE);
      }
    }
  }
}

void fit_to_window (TM *tm) {
  int width, height;

  if (strcmp(tm->tcfg->fit_next, "no") == 0) {
    gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);

    if (tm->tgtk->image != NULL) {
      gtk_widget_destroy(tm->tgtk->image);
    }
    tm->tnfo->image_full_path = malloc(strlen(tm->tnfo->image_dirname) + strlen(tm->tnfo->image_list_basename[tm->tnfo->pos]) + 1);
    strcpy(tm->tnfo->image_full_path, tm->tnfo->image_dirname);
    strcpy(tm->tnfo->image_full_path, tm->tnfo->image_list_basename[tm->tnfo->pos]);
    //    printf("dirname = %s base = %s\n", tm->tnfo->image_dirname, tm->tnfo->image_list_basename[tm->tnfo->pos]);
    tm->tgtk->pixbuf = gdk_pixbuf_new_from_file_at_scale(tm->tnfo->image_full_path, width - 300, height - 100, TRUE, NULL);
    tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
	tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_full_path, NULL);
    gtk_widget_show(tm->tgtk->image);
    //    strcpy(tm->tcfg->fit_next, "yes");
  } else {
    gtk_window_get_size(GTK_WINDOW(tm->tgtk->window), &width, &height);

    if (tm->tgtk->image != NULL) {
      gtk_widget_destroy(tm->tgtk->image);
    }
    tm->tnfo->image_full_path = malloc(strlen(tm->tnfo->image_dirname) + strlen(tm->tnfo->image_list_basename[tm->tnfo->pos]) + 1);
    strcpy(tm->tnfo->image_full_path, tm->tnfo->image_dirname);
    strcpy(tm->tnfo->image_full_path, tm->tnfo->image_list_basename[tm->tnfo->pos]);

    tm->tgtk->pixbuf = gdk_pixbuf_new_from_file(tm->tnfo->image_full_path, NULL);
    tm->tgtk->image = gtk_image_new_from_pixbuf(tm->tgtk->pixbuf);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tm->tgtk->scrolled), tm->tgtk->image);
	tm->tgtk->pixbuf_orig = gdk_pixbuf_new_from_file(tm->tnfo->image_full_path, NULL);
	//    strcpy(tm->tcfg->fit_next, "no");
  }

}
