#include "header.h"

void put_settings (TM *tm) {
  GtkWidget *grid1, *grid11, *grid12, *grid13;
  GtkWidget *label;
  GtkWidget *button1, *button2;

  tm->tgtk->window_settings = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  //  gtk_window_set_default_size(GTK_WINDOW(window), 380, 440);
  //  gtk_widget_set_size_request(window, 320, 440);
  gtk_window_set_resizable(GTK_WINDOW(tm->tgtk->window_settings), FALSE);
  gtk_window_set_position(GTK_WINDOW(tm->tgtk->window_settings), GTK_WIN_POS_CENTER);
  gtk_container_set_border_width(GTK_CONTAINER(tm->tgtk->window_settings), 10);
  gtk_window_set_title(GTK_WINDOW(tm->tgtk->window_settings), "NeonView Settings");

  grid1 = gtk_grid_new();
  gtk_container_add(GTK_CONTAINER(tm->tgtk->window_settings), grid1);
  grid11 = gtk_grid_new();
  gtk_grid_attach(GTK_GRID(grid1), grid11, 0, 0, 1, 1);
  grid12 = gtk_grid_new();
  gtk_grid_attach(GTK_GRID(grid1), grid12, 0, 1, 1, 1);
  grid13 = gtk_grid_new();
  gtk_grid_attach(GTK_GRID(grid1), grid13, 0, 2, 1, 1);

  GtkWidget *notebook, *ngrid1, *ngrid2, *title1, *title2;

  notebook = gtk_notebook_new();
  ngrid1 = gtk_grid_new();
  ngrid2 = gtk_grid_new();
  title1 = gtk_label_new("Application");
  title2 = gtk_label_new("Images");
  gtk_widget_set_size_request(notebook, 400, 180);
  //  gtk_widget_set_vexpand(notebook, TRUE);
  gtk_widget_set_hexpand(notebook, TRUE);
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), ngrid1, title1);
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), ngrid2, title2);
  gtk_grid_attach(GTK_GRID(grid11), notebook, 0, 0, 1, 1);

  label = gtk_label_new("This is the NeonView configuration window, allowing you to change various aspects of NeonView. Mouse-over each option to get a brief description in this area.");
  gtk_widget_set_size_request(label, 400, 100);
  gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
  gtk_label_set_line_wrap_mode(GTK_LABEL(label), PANGO_WRAP_WORD_CHAR);
  gtk_label_set_max_width_chars(GTK_LABEL(label), 24);
  gtk_widget_set_margin_top(label, 10);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
  gtk_grid_attach(GTK_GRID(grid12), label, 0, 1, 1, 1);

  button1 = gtk_button_new_with_mnemonic("_Cancel");
  button2 = gtk_button_new_with_mnemonic("_OK");
  gtk_widget_set_size_request(button1, 40, 32);
  gtk_widget_set_size_request(button2, 40, 32);
  gtk_grid_set_column_homogeneous(GTK_GRID(grid13), TRUE);
  gtk_grid_attach(GTK_GRID(grid13), button1, 0, 0, 1, 1);
  gtk_grid_attach(GTK_GRID(grid13), button2, 1, 0, 1, 1);
  gtk_widget_set_margin_top(grid13, 10);
  gtk_widget_set_hexpand(grid13, TRUE);

  // notebook page 1
  GtkWidget *ebox11, *ebox12;
  GtkWidget *subtitle11, *check11, *check12;

  ebox11 = gtk_event_box_new();
  ebox12 = gtk_event_box_new();

  subtitle11 = gtk_label_new(NULL);
  gtk_label_set_markup(GTK_LABEL(subtitle11), "<b>Main Window</b>");
  gtk_misc_set_alignment(GTK_MISC(subtitle11), 0, 0);
  gtk_widget_set_margin_top(subtitle11, 10);
  gtk_widget_set_margin_left(subtitle11, 10);
  gtk_grid_attach(GTK_GRID(ngrid1), subtitle11, 0, 0, 1, 1);

  check11 = gtk_check_button_new_with_label("Start maximized");
  gtk_widget_set_margin_top(check11, 10);
  gtk_widget_set_margin_left(check11, 20);
  gtk_container_add(GTK_CONTAINER(ebox11), check11);
  gtk_grid_attach(GTK_GRID(ngrid1), ebox11, 0, 1, 1, 1);
  g_signal_connect_swapped(ebox11, "enter-notify-event", G_CALLBACK(show_hint11), label);
  g_signal_connect_swapped(ebox11, "leave-notify-event", G_CALLBACK(show_hint00), label);

  check12 = gtk_check_button_new_with_label("Remember window size");
  gtk_widget_set_margin_left(check12, 20);
  gtk_container_add(GTK_CONTAINER(ebox12), check12);
  gtk_grid_attach(GTK_GRID(ngrid1), ebox12, 0, 2, 1, 1);
  g_signal_connect_swapped(ebox12, "enter-notify-event", G_CALLBACK(show_hint12), label);
  g_signal_connect_swapped(ebox12, "leave-notify-event", G_CALLBACK(show_hint00), label);

  // notebook page2
  GtkWidget *ebox21, *ebox22;
  GtkWidget *subtitle21, *check21, *check22;

  ebox21 = gtk_event_box_new();
  ebox22 = gtk_event_box_new();

  subtitle21 = gtk_label_new(NULL);
  gtk_label_set_markup(GTK_LABEL(subtitle21), "<b>Behavior</b>");
  gtk_misc_set_alignment(GTK_MISC(subtitle21), 0, 0);
  gtk_widget_set_margin_top(subtitle21, 10);
  gtk_widget_set_margin_left(subtitle21, 10);
  gtk_grid_attach(GTK_GRID(ngrid2), subtitle21, 0, 0, 1, 1);

  check21 = gtk_check_button_new_with_label("Remember fit to window");
  gtk_widget_set_margin_top(check21, 10);
  gtk_widget_set_margin_left(check21, 20);
  gtk_container_add(GTK_CONTAINER(ebox21), check21);
  gtk_grid_attach(GTK_GRID(ngrid2), ebox21, 0, 1, 1, 1);
  g_signal_connect_swapped(ebox21, "enter-notify-event", G_CALLBACK(show_hint21), label);
  g_signal_connect_swapped(ebox21, "leave-notify-event", G_CALLBACK(show_hint00), label);

  check22 = gtk_check_button_new_with_label("Lock fit to window");
  gtk_widget_set_margin_left(check22, 20);
  gtk_container_add(GTK_CONTAINER(ebox22), check22);
  gtk_grid_attach(GTK_GRID(ngrid2), ebox22, 0, 2, 1, 1);
  g_signal_connect_swapped(ebox22, "enter-notify-event", G_CALLBACK(show_hint22), label);
  g_signal_connect_swapped(ebox22, "leave-notify-event", G_CALLBACK(show_hint00), label);

  // fill in check boxes
  if (strcmp(tm->tcfg->start_maximized, "yes") == 0) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check11), TRUE);
  }
  if (strcmp(tm->tcfg->remember_window_size, "yes") == 0) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check12), TRUE);
  }
  if (strcmp(tm->tcfg->remember_fit, "yes") == 0) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check21), TRUE);
  }
  if (strcmp(tm->tcfg->fit_next, "yes") == 0) {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check22), TRUE);
  }

  g_signal_connect_swapped(check11, "toggled", G_CALLBACK(toggle_start_maximized), tm);
  g_signal_connect_swapped(check12, "toggled", G_CALLBACK(toggle_remember_window_size), tm);
  g_signal_connect_swapped(check21, "toggled", G_CALLBACK(toggle_remember_fit), tm);
  g_signal_connect_swapped(check22, "toggled", G_CALLBACK(toggle_fit_next), tm);

  g_signal_connect_swapped(button1, "clicked", G_CALLBACK(settings_cancel), tm);
  g_signal_connect_swapped(button2, "clicked", G_CALLBACK(settings_ok), tm);

  strcpy(tm->tcfg->tmp_start_maximized, tm->tcfg->start_maximized);
  strcpy(tm->tcfg->tmp_remember_window_size, tm->tcfg->remember_window_size);
  strcpy(tm->tcfg->tmp_remember_fit, tm->tcfg->remember_fit);
  strcpy(tm->tcfg->tmp_fit_next, tm->tcfg->fit_next);

  GtkAccelGroup *accel_group;
  accel_group = gtk_accel_group_new();
  gtk_window_add_accel_group(GTK_WINDOW(tm->tgtk->window_settings), accel_group);
  gtk_widget_add_accelerator(button1, "activate", accel_group, GDK_KEY_Escape, 0, GTK_ACCEL_VISIBLE);

  gtk_widget_show_all(grid1);
  gtk_widget_show(tm->tgtk->window_settings);
}

void show_hint00 (GtkWidget *widget) {
  gtk_label_set_text(GTK_LABEL(widget), "This is the NeonView configuration window, allowing you to change various aspects of NeonView. Mouse-over each option to get a brief description about it in this area.");
}

void show_hint11 (GtkWidget *widget) {
  gtk_label_set_text(GTK_LABEL(widget), "If this is checked, NeonView will start maximized even if Remember window size is checked. NeonView will still remember the window size between sessions, but it will ignore it and automatically start maximized.");
}

void show_hint12 (GtkWidget *widget) {
  gtk_label_set_text(GTK_LABEL(widget), "If this is checked, NeonView will remember the window size and restore it between sessions. Notice that if Start maximized is also checked, this option will be ignored, even though the last known size of the window will be saved.");
}

void show_hint21 (GtkWidget *widget) {
  gtk_label_set_text(GTK_LABEL(widget), "If this is checked, NeonView will remember the fit to window option between sessions. This means that when NeonView starts, it will display images according to the last state of the Fit to Window option.");
}

void show_hint22 (GtkWidget *widget) {
  gtk_label_set_text(GTK_LABEL(widget), "If this is checked, NeonView will display next and previous images depending on the state of the Fit to Window option, rather than resetting the image size to normal, which is the default.");
}

void toggle_start_maximized (TM *tm, GtkWidget *widget) {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) == TRUE) {
    strcpy(tm->tcfg->tmp_start_maximized, "yes");
  } else {
    strcpy(tm->tcfg->tmp_start_maximized, "no");
  }
}

void toggle_remember_window_size (TM *tm, GtkWidget *widget) {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) == TRUE) {
    strcpy(tm->tcfg->tmp_remember_window_size, "yes");
  } else {
    strcpy(tm->tcfg->tmp_remember_window_size, "no");
  }
}

void toggle_remember_fit (TM *tm, GtkWidget *widget) {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) == TRUE) {
    strcpy(tm->tcfg->tmp_remember_fit, "yes");
  } else {
    strcpy(tm->tcfg->tmp_remember_fit, "no");
  }
}

void toggle_fit_next (TM *tm, GtkWidget *widget) {
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) == TRUE) {
    strcpy(tm->tcfg->tmp_fit_next, "yes");
  } else {
    strcpy(tm->tcfg->tmp_fit_next, "no");
  }
}

void settings_ok (TM *tm) {
  strcpy(tm->tcfg->start_maximized, tm->tcfg->tmp_start_maximized);
  strcpy(tm->tcfg->remember_window_size, tm->tcfg->tmp_remember_window_size);
  strcpy(tm->tcfg->remember_fit, tm->tcfg->tmp_remember_fit);
  strcpy(tm->tcfg->fit_next, tm->tcfg->tmp_fit_next);
  gtk_widget_destroy(tm->tgtk->window_settings);
}

void settings_cancel (TM *tm) {
  gtk_widget_destroy(tm->tgtk->window_settings);
}
