#include "header.h"

// convert a string to lowercase, modifies argument
char *lc (char *str) {
  int i;

  for (i = 0; i < strlen(str); i++) {
    if (str[i] >= 65 && str[i] <= 92) {
      str[i] = str[i] + 32;
    }
  }
  return str;
}

// return 0 if a string contains only digits, 1 otherwise
int all_digits (char *str) {
  int i;

  for (i = 0; i < strlen(str); i++) {
    if (str[i] < 48 || str[i] > 57) {
      return 1;
    }
  }

  return 0;
}

// reverse string, modifies argument
char *rts (char *str) {
  int len, i;
  char tmp;

  len = strlen(str) - 1;
  for (i = 0; i < strlen(str) / 2; i++) {
    tmp = str[len];
    str[len] = str[i];
    str[i] = tmp;
    len--;
  }

  return str;
}

// return size of a file in bytes
long filesize (char *str) {
  FILE *file;
  long filesize;

  file = fopen(str, "rb");
  if (!file) {
    return -1;
  }
  fseek(file, 0, SEEK_END);
  filesize = ftell(file);
  fclose(file);

  return filesize;
}

// return 1000 if file exists, 1100 r--, 1110 rw-, 1111 rwx
int perms (char *str) {
  int rv = 0;

  if (access(str, F_OK) == 0) {
    rv = rv + 1000;
  }
  if (access(str, R_OK) == 0) {
    rv = rv + 100;
  }
  if (access(str, W_OK) == 0) {
    rv = rv + 10;
  }
  if (access(str, X_OK) == 0) {
    rv = rv + 1;
  }

  return rv;
}

// count digits in an integer
int digits (int n) {
  int digits;

  if (n == 0) {
    return 1;
  }

  digits = 0;
  while (n > 0) {
    n = n / 10;
    digits++;
  }

  return digits;
}
