#include "header.h"

// remove spaces and double-quote characters in a string, modifies initial string
void remove_spaces (char *str) {
  char tmp[strlen(str)];
  int i, j = 0;

  for (i = 0; i < strlen(str); i++) {
    if (str[i] != ' ' && str[i] != '"') {
      tmp[j] = str[i];
      j++;
    }
  }
  tmp[j] = '\0';
  strcpy(str, tmp);
}

void assign_keys (TM *tm, char *key, char *val) {
  int n;

  if (strcmp(key, "last_dir") == 0) {
    strcpy(tm->tcfg->last_dir, val);
  }
  if (strcmp(key, "start_dir") == 0) {
    strcpy(tm->tcfg->start_dir, val);
  }
  if (strcmp(key, "window_width") == 0) {
    if (all_digits(val) == 0) {
      sscanf(val, "%d", &n);
      if (n < 2560 * 2) {
	tm->tcfg->window_width = n;
      } else {
	fprintf(stdout, "[NeonView] WARNING: Invalid config value (value too big): %s=%s\n", key, val);
	fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
      }
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "window_height") == 0) {
    if (all_digits(val) == 0) {
      sscanf(val, "%d", &n);
      if (n < 1440 * 2) {
	tm->tcfg->window_height = n;
      } else {
	fprintf(stdout, "[NeonView] WARNING: Invalid config value (value too big): %s=%s\n", key, val);
	fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
      }
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "start_maximized") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->start_maximized, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "show_toolbar") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->show_toolbar, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "show_status") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->show_status, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "show_left_sidebar") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->show_left_sidebar, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "show_right_sidebar") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->show_right_sidebar, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "remember_fit") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->remember_fit, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "fit_next") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->fit_next, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "remember_zoom") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->remember_zoom, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "remember_window_size") == 0) {
    if (strcmp(val, "yes") == 0 || strcmp(val, "no") == 0) {
      strcpy(tm->tcfg->remember_window_size, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "window_title") == 0) {
    if (strlen(val) >= 0 && strlen(val) <= 64) {
      strcpy(tm->tcfg->window_title, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value (maximum 64 characters): %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "gtk_win_pos") == 0) {
    if (strcmp(val, "GTK_WIN_POS_NONE") == 0 || strcmp(val, "GTK_WIN_POS_CENTER") == 0 ||
	strcmp(val, "GTK_WIN_POS_MOUSE") == 0 || strcmp(val, "GTK_WIN_POS_CENTER_ALWAYS") == 0 ||
	strcmp(val, "GTK_WIN_POS_CENTER_ON_PARENT") == 0) {
      strcpy(tm->tcfg->gtk_win_pos, val);
    } else {
      fprintf(stdout, "[NeonView] WARNING: Invalid config value: %s=%s\n", key, val);
      fprintf(stdout, "[NeonView] WARNING: Using default value.\n");
    }
  }
  if (strcmp(key, "last_dir") != 0 && strcmp(key, "start_dir") != 0 && strcmp(key, "window_width") != 0 &&
      strcmp(key, "window_height") != 0 && strcmp(key, "start_maximized") != 0 && strcmp(key, "show_toolbar") != 0 &&
      strcmp(key, "show_status") != 0 && strcmp(key, "show_left_sidebar") != 0 && strcmp(key, "remember_fit") != 0 &&
      strcmp(key, "fit_next") != 0 && strcmp(key, "remember_zoom") != 0 && strcmp(key, "remember_window_size") != 0 &&
      strcmp(key, "window_title") != 0 && strcmp(key, "gtk_win_pos") != 0 && strcmp(key, "show_right_sidebar") != 0) {
    fprintf(stdout, "[NeonView] WARNING: Invalid config key: %s=%s\n", key, val);
    fprintf(stdout, "[NeonView] WARNING: Ignored.\n");
  }
}

void print_config (TM *tm) {
  fprintf(stdout, "--------------------------------------------------------------------------------\n");
  fprintf(stdout, "last_dir=%s\n", tm->tcfg->last_dir);
  fprintf(stdout, "start_dir=%s\n", tm->tcfg->start_dir);
  fprintf(stdout, "window_width=%d\n", tm->tcfg->window_width);
  fprintf(stdout, "window_height=%d\n", tm->tcfg->window_height);
  fprintf(stdout, "start_maximized=%s\n", tm->tcfg->start_maximized);
  fprintf(stdout, "show_toolbar=%s\n", tm->tcfg->show_toolbar);
  fprintf(stdout, "show_status=%s\n", tm->tcfg->show_status);
  fprintf(stdout, "show_left_sidebar=%s\n", tm->tcfg->show_left_sidebar);
  fprintf(stdout, "show_right_sidebar=%s\n", tm->tcfg->show_right_sidebar);
  fprintf(stdout, "remember_fit=%s\n", tm->tcfg->remember_fit);
  fprintf(stdout, "fit_next=%s\n", tm->tcfg->fit_next);
  fprintf(stdout, "remember_zoom=%s\n", tm->tcfg->remember_zoom);
  fprintf(stdout, "remember_window_size=%s\n", tm->tcfg->remember_window_size);
  fprintf(stdout, "window_title=%s\n", tm->tcfg->window_title);
  fprintf(stdout, "gtk_win_pos=%s\n", tm->tcfg->gtk_win_pos);
  fprintf(stdout, "--------------------------------------------------------------------------------\n");
}

void check_keys (TM *tm) {
  // skele
}

void init_keys (TM *tm) {
  strcpy(tm->tcfg->last_dir, ".");
  strcpy(tm->tcfg->start_dir, ".");
  tm->tcfg->window_width = 840;
  tm->tcfg->window_height = 480;
  strcpy(tm->tcfg->start_maximized, "no");
  strcpy(tm->tcfg->show_toolbar, "yes");
  strcpy(tm->tcfg->show_status, "yes");
  strcpy(tm->tcfg->show_left_sidebar, "yes");
  strcpy(tm->tcfg->show_right_sidebar, "yes");
  strcpy(tm->tcfg->remember_fit, "no");
  strcpy(tm->tcfg->fit_next, "yes");
  strcpy(tm->tcfg->remember_zoom, "no");
  strcpy(tm->tcfg->remember_window_size, "yes");
  strcpy(tm->tcfg->window_title, "NeonView");
  strcpy(tm->tcfg->gtk_win_pos, "GTK_WIN_POS_CENTER");
}

int get_win_pos (char *str) {
  if (strcmp(str, "GTK_WIN_POS_NONE") == 0) {
    return 0;
  }
  if (strcmp(str, "GTK_WIN_POS_CENTER") == 0) {
    return 1;
  }
  if (strcmp(str, "GTK_WIN_POS_MOUSE") == 0) {
    return 2;
  }
  if (strcmp(str, "GTK_WIN_POS_CENTER_ALWAYS") == 0) {
    return 3;
  }
  if (strcmp(str, "GTK_WIN_POS_CENTER_ON_PARENT") == 0) {
    return 4;
  }
  return 1;
}

void init_struct (TM *tm) {
  tm->tgtk->pixbuf = NULL;
  tm->tgtk->pixbuf_next = NULL;
  tm->tgtk->pixbuf_prev = NULL;
  tm->tgtk->image = NULL;
  tm->tgtk->notebook1 = NULL;

  tm->tnfo->image_dirname = NULL;
  tm->tnfo->image_basename = NULL;
  tm->tnfo->image_path = NULL;
  tm->tnfo->image_full_path = NULL;
  tm->tnfo->image_list = NULL;

  tm->tnfo->total = 0;
  tm->tnfo->pos = 0;

  tm->tnfo->isgif = 0;
  tm->tnfo->isfit = 0;
}

// check extension of the given string, return 1 if it's an image, 0 otherwise
int check_ext (char *str) {
  int i, j;
  char ext[256]; // why doesn't char *ext with malloc work here?
  /*
    ext = malloc((strlen(str) + 1)); // allocate possibly more than enough
    if (!ext) {
    criterr(0);
    }
  */
  i = strlen(str) - 1;
  j = 0;

  int stop = 0;
  while (i >= 0 && stop == 0) {
    if (str[i] != '.') {
      ext[j] = str[i];
      j++;
    } else {
      ext[j] = '\0';
      stop = 1;
    }
    i--;
  }

  if (i == 0) {
    return 0; // file has no extension?
  }

  rts(ext);
  lc(ext);

  if (strcmp(ext, "gif") == 0) {
    return 2;
  }

  // formats supported by GdkPixbuf
  if (strcmp(ext, "png") == 0 || strcmp(ext, "ico") == 0 || strcmp(ext, "cur") == 0 ||
      strcmp(ext, "ani") == 0 || strcmp(ext, "ras") == 0 || strcmp(ext, "pcx") == 0 ||
      strcmp(ext, "xbm") == 0 || strcmp(ext, "tga") == 0 || strcmp(ext, "targa") == 0 ||
      strcmp(ext, "svg") == 0 || strcmp(ext, "svgz") == 0 || strcmp(ext, "jpeg") == 0 ||
      strcmp(ext, "jpe") == 0 || strcmp(ext, "jpg") == 0 || strcmp(ext, "tiff") == 0 ||
      strcmp(ext, "tif") == 0 || strcmp(ext, "xpm") == 0 || strcmp(ext, "bmp") == 0 ||
      strcmp(ext, "pnm") == 0 || strcmp(ext, "pbm") == 0 || strcmp(ext, "pgm") == 0 ||
      strcmp(ext, "ppm") == 0 || strcmp(ext, "qtif") == 0 || strcmp(ext, "qif") == 0 ||
      strcmp(ext, "jp2") == 0 || strcmp(ext, "jpc") == 0 || strcmp(ext, "jpx") == 0 ||
      strcmp(ext, "j2k") == 0 || strcmp(ext, "jpf") == 0 || strcmp(ext, "wbmp") == 0 ||
      strcmp(ext, "gif") == 0 || strcmp(ext, "icns") == 0) {
    return 1;
  }

  return 0;
}

int fisfile (char *str) {
  if (access(str, R_OK) == 0) {
    return 1; // file exists and can be opened for reading
  } else {
    return 0; // cannot open file for reading
  }
  return 0;
}

void get_full_path (TM *tm) {
  if (tm->tnfo->image_path[0] != '/') { // not an absolute path
    tm->tnfo->image_full_path = malloc(strlen(tm->tenv->cwd) + strlen(tm->tnfo->image_path) + 2);
    if (!tm->tnfo->image_full_path) {
      criterr(0);
    }
    strcpy(tm->tnfo->image_full_path, tm->tenv->cwd);
    strcat(tm->tnfo->image_full_path, "/");
    strcat(tm->tnfo->image_full_path, tm->tnfo->image_path);
  } else {
    tm->tnfo->image_full_path = malloc(strlen(tm->tnfo->image_path) + 1);
    if (!tm->tnfo->image_full_path) {
      criterr(0);
    }
    strcpy(tm->tnfo->image_full_path, tm->tnfo->image_path);
  }
}

void get_dirname (TM *tm) {
  int i = strlen(tm->tnfo->image_full_path) - 1, stop = 0, j = 0;

  tm->tnfo->image_dirname = malloc(strlen(tm->tnfo->image_full_path) + 1);
  tm->tnfo->image_basename = malloc(strlen(tm->tnfo->image_full_path) + 1);
  if (!tm->tnfo->image_dirname || !tm->tnfo->image_basename) {
    criterr(0);
  }

  j = 0;
  while (i >= 0 && stop == 0) {
    if (tm->tnfo->image_full_path[i] == '/') {
      stop = 1;
    } else {
      i--;
      j++;
    }
  }

  for (i = 0; i < strlen(tm->tnfo->image_full_path) - j - 1; i++) {
    tm->tnfo->image_dirname[i] = tm->tnfo->image_full_path[i];
  }
  tm->tnfo->image_dirname[i] = '\0';

  int k = 0;
  for (i = strlen(tm->tnfo->image_full_path) - j - 1; i < strlen(tm->tnfo->image_full_path); i++) {
    tm->tnfo->image_basename[k] = tm->tnfo->image_full_path[i];
    k++;
  }
  tm->tnfo->image_basename[k] = '\0';

  fprintf(stdout, "[NeonView] Current directory: %s\n", tm->tnfo->image_dirname);
}
